unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, shellapi, CRC16, CRC32;

type
  TformMenuPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    bSelFichero: TButton;
    Label1: TLabel;
    txtFichero: TEdit;
    lNombre: TLabel;
    lTamano: TLabel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    txtCRCTexto: TEdit;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    txtCRC16Dec: TEdit;
    txtCRC32Dec: TEdit;
    txtCRC16Hex: TEdit;
    txtCRC32Hex: TEdit;
    LWEB: TLabel;
    lInfo: TLabel;
    dlAbrir: TOpenDialog;
    procedure LWEBClick(Sender: TObject);
    procedure txtCRCTextoChange(Sender: TObject);
    procedure actualizarDatos();
    procedure FormCreate(Sender: TObject);
    procedure txtFicheroChange(Sender: TObject);
    procedure bSelFicheroClick(Sender: TObject);
  private
    { Private declarations }
    CRC16    :  WORD;
    CRC16File:  WORD;
    CRC16Text:  WORD;

    CRC32    :  LongWORD;
    CRC32File:  LongWord;
    CRC32Text:  LongWord;

  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.actualizarDatos();
begin
  txtCRC16Dec.Text := IntToStr(CRC16);
  txtCRC16Hex.Text := IntToHex(CRC16,4);
  txtCRC32Dec.Text := IntToStr(CRC32);
  txtCRC32Hex.Text := IntToHex(CRC32, 8)
end;

procedure TformMenuPrincipal.txtCRCTextoChange(Sender: TObject);
var
  s : string;
begin
  s := txtCRCTexto.Text;
  CRC16Text := $FFFF;
  if Length(s) > 0 then
    CalcCRC16 (Addr(s[1]), length(s), CRC16Text);
  CRC16Text := not CRC16Text;

  CRC32Text := $FFFFFFFF;   // Para que coincida con PKZIP
  if Length(s) > 0 then
    CalcCRC32 (Addr(s[1]), length(s), CRC32Text);
  CRC32Text := not CRC32Text; 

  CRC16 := CRC16Text;
  CRC32 := CRC32Text;
  actualizarDatos;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  CRC16File := 0;
  CRC16Text := 0;

  CRC32File := 0;
  CRC32Text := 0
end;

procedure TformMenuPrincipal.txtFicheroChange(Sender: TObject);
const
  BufferSize = 16384;

var
  IOBuffer :  array of Byte;
  Error16  :  WORD;
  Error32  :  WORD;
  FileBytes:  TInteger8;
  nombreFichero : string;
begin
  nombreFichero := txtFichero.Text;
  if FileExists(nombreFichero) then
  begin
    lNombre.Caption := nombreFichero;
    lNombre.Hint := nombreFichero;

    SetLength(IOBuffer, BufferSize);
    CalcFileCRC16 (nombreFichero, CRC16File, pByte(IOBuffer),
        BufferSize, Error16);
    CalcFileCRC32 (nombreFichero, CRC32File, FileBytes, Error32);

    lTamano.Caption := IntToStr(FileBytes) + ' bytes';

    if Error16 <> 0 then
      lInfo.Caption := 'Error al obtener CRC16';
    if Error32 <> 0 then
      lInfo.Caption := lInfo.Caption + '  Erro al obtener CRC32';

    CRC16 := CRC16File;
    CRC32 := CRC32File;
    actualizarDatos;
  end;
end;

procedure TformMenuPrincipal.bSelFicheroClick(Sender: TObject);
begin
  if dlAbrir.Execute then
    txtFichero.Text := dlAbrir.FileName;
end;

end.
